module Random (
    StdGen,
    newStdGen,
    splitR,
    randomR
    ) where

import Language.Fay.Prelude
import Language.Fay.FFI

unsafeRand :: Double -> Double -> Double
unsafeRand = ffi "Math.random()*%2+%1"

-- TODO: This is an ugly, kludgy, awful hack.  We really want a purely
-- functional random number generator.  But that's hard, so instead, we
-- fake it, but really unsafely pick random numbers from the one above.
-- Passing around the StdGen essentially uses data flow to force a
-- re-evaluation of the unsafe expression.

data StdGen = StdGen

newStdGen :: Fay StdGen
newStdGen = return StdGen

splitR :: StdGen -> (StdGen, StdGen)
splitR g = (g, g)

randomR :: (Double, Double) -> StdGen -> (Double, StdGen)
randomR (lo, hi) g = (unsafeRand lo (hi - lo), g)
