{-# LANGUAGE EmptyDataDecls    #-}

module Web where

import Language.Fay.Prelude
import Language.Fay.FFI

data Element
instance Foreign Element

getElementById :: String -> Fay Element
getElementById = ffi "document['getElementById'](%1)"

focusElement :: Element -> Fay ()
focusElement = ffi "%1.focus()"

data Ref a
instance Foreign a => Foreign (Ref a)

newRef :: Foreign a => a -> Fay (Ref a)
newRef = ffi "new Fay$$Ref(%1)"

writeRef :: Foreign a => Ref a -> a -> Fay ()
writeRef = ffi "Fay$$writeRef(%1,%2)"

readRef :: Foreign a => Ref a -> Fay a
readRef = ffi "Fay$$readRef(%1)"

currentTimeMillis :: Fay Double
currentTimeMillis = ffi "(Date.now?Date.now():new Date().getTime())"

data Context
instance Foreign Context

getContext :: Element -> String -> Fay Context
getContext = ffi "%1['getContext'](%2)"

clearRect :: Context -> Double -> Double -> Double -> Double -> Fay ()
clearRect = ffi "%1['clearRect'](%2,%3,%4,%5)"

save :: Context -> Fay ()
save = ffi "%1['save']()"

restore :: Context -> Fay ()
restore = ffi "%1['restore']()"

canvasTranslate :: Context -> Double -> Double -> Fay ()
canvasTranslate = ffi "%1['translate'](%2,%3)"

canvasScale :: Context -> Double -> Double -> Fay ()
canvasScale = ffi "%1['scale'](%2,%3)"

transform :: Context
          -> Double -> Double -> Double -> Double -> Double -> Double
          -> Fay ()
transform = ffi "%1['transform'](%2,%3,%4,%5,%6,%7)"

setTextAlign :: Context -> String -> Fay ()
setTextAlign = ffi "%1['textAlign']=%2"

setTextBaseline :: Context -> String -> Fay ()
setTextBaseline = ffi "%1['textBaseline']=%2"

setLineWidth :: Context -> Double -> Fay ()
setLineWidth = ffi "%1['lineWidth']=%2"

setFont :: Context -> String -> Fay ()
setFont = ffi "%1['font']=%2"

setStrokeStyle :: Context -> String -> Fay ()
setStrokeStyle = ffi "%1['strokeStyle']=%2"

setFillStyle :: Context -> String -> Fay ()
setFillStyle = ffi "%1['fillStyle']=%2"

beginPath :: Context -> Fay ()
beginPath = ffi "%1['beginPath']()"

closePath :: Context -> Fay ()
closePath = ffi "%1['closePath']()"

fill :: Context -> Fay ()
fill = ffi "%1['fill']()"

stroke :: Context -> Fay ()
stroke = ffi "%1['stroke']()"

fillText :: Context ->String -> Double -> Double -> Fay ()
fillText = ffi "%1['fillText'](%2,%3,%4)"

moveTo :: Context -> Double -> Double -> Fay ()
moveTo = ffi "%1['moveTo'](%2,%3)"

lineTo :: Context -> Double -> Double -> Fay ()
lineTo = ffi "%1['lineTo'](%2,%3)"

canvasArc :: Context -> Double -> Double -> Double -> Double -> Double -> Bool -> Fay ()
canvasArc = ffi "%1['arc'](%2,%3,%4,%5,%6,%7)"

